; 

    .386
    .model flat,stdcall
    option casemap:none

    include \masm32\include\user32.inc
    include \masm32\include\advapi32.inc
    include \masm32\include\windows.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\advapi32.lib
    include \masm32\include\masm32.inc

    wsprintf TEXTEQU <wsprintfA>

    GetPid          PROTO :DWORD
    
    CTEXT MACRO y:VARARG
        LOCAL sym, dummy
        dummy EQU $;; MASM error fix
        CONST segment
        IFIDNI <y>,<>
            sym db 0
        ELSE
            sym db y,0
        ENDIF
        CONST ends
        EXITM <OFFSET sym>
    ENDM

.const
    WM_REMOTEHOOK equ WM_USER+6

.data
    char         dd 0
    hInstance    dd 0
    NotepadTitle db "Untitled - Notepad",0
    NotepadClass db "Notepad",0
    ;RemoteTitle db "",0
    RemoteClass  db "Winamp v1.x",0
    template     db "%lx",0
    filehandle   dd 0
    ThePID       dd 0
    
.data?
    hRemoteHook dd ?
    NotepadHandle DWORD ?
    modhand dd ?
    RemotePID DWORD ?
    hWnd dd ?

; 

.code
DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    push hInst
    pop hInstance
    mov  eax,TRUE
    ret
DllEntry Endp

RemoteHookProc proc nCode:DWORD,wParam:DWORD,lParam:DWORD
    LOCAL buffer[128]:byte
    .if nCode<0
        invoke CallNextHookEx,hRemoteHook,nCode,wParam,lParam
        ret
    .endif

    mov edx,lParam
    assume edx:PTR CWPSTRUCT

        .if [edx].message == 12 ; 0xC = WM_SETTEXT
            invoke MessageBox,hWnd,[edx].lParam,CTEXT('Now Playing...'),0
        .elseif [edx].message == 273 ; 0x111 = WM_COMMAND
            .if [edx].wParam == 40048 ; 0x9C70 = next song :)
                invoke MessageBox,0,CTEXT('You are playing the next song'),CTEXT('Cool'),0
            .endif
        .endif

    assume edx:nothing

    xor eax,eax    
    ret
RemoteHookProc endp

InstallHook proc hwnd:DWORD
    push hwnd
    pop hWnd

    ;invoke PostMessage,NotepadHandle,WM_CHAR,65,0

    ;push offset RemoteTitle
    push NULL
    push offset RemoteClass
    call FindWindow

    push offset RemotePID
    push eax
    call GetWindowThreadProcessId
    ;Invoke GetPid,CTEXT ('winamp.exe')
    mov RemotePID,eax

    .if RemotePID == NULL
        ; The target isn't running, and we definitely don't want a global hook!
        invoke MessageBox,0,CTEXT('Target process not running'),CTEXT('DLL Says'),0
        xor eax,eax
        ret
    .endif

    invoke GetModuleHandle, CTEXT ('dll.dll')
    mov ebx, eax
    

    
    ;invoke SetWindowsHookEx,WH_KEYBOARD,addr RemoteHookProc,ebx,RemotePID
    invoke SetWindowsHookEx,WH_CALLWNDPROC,addr RemoteHookProc,ebx,RemotePID
    

    
    
    .if eax==NULL
        call GetLastError
    .else
        mov hRemoteHook,eax
    .endif
    
    ret
InstallHook endp

UninstallHook proc
    invoke _lclose,filehandle
    invoke UnhookWindowsHookEx,hRemoteHook
    ret
UninstallHook endp


GetPid proc szFile:dword
 LOCAL Process:PROCESSENTRY32
   mov Process.dwSize, sizeof Process
   invoke CreateToolhelp32Snapshot, 2, 0
   mov esi, eax
   invoke Process32First, esi, addr Process
   @@loop:
   invoke lstrcmpiA,szFile, addr Process.szExeFile
       test eax, eax
       jnz @@continue
    ;if we are here then we got the pid (Process.th32ProcessID}
     push Process.th32ProcessID
     pop ThePID
     jmp @@done
   @@continue:
     invoke Process32Next, esi, addr Process
       test eax, eax
       jz @@done
     jmp @@loop
   @@done:
       invoke CloseHandle, esi
       ret
GetPid endp

End DllEntry 
