; 

    .386
    .model flat,stdcall
    option casemap:none
    
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include dll.inc
    
    includelib dll.lib
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    
    
    CTEXT MACRO y:VARARG
        LOCAL sym, dummy
        dummy EQU $;; MASM error fix
        CONST segment
        IFIDNI <y>,<>
            sym db 0
        ELSE
            sym db y,0
        ENDIF
        CONST ends
        EXITM <OFFSET sym>
    ENDM
    
    .const
    
    WM_REMOTEHOOK equ WM_USER+6
    
    WndProc   PROTO :DWORD,:DWORD,:DWORD,:DWORD; define procedure
    
    .data
    
    HookFlag dd FALSE
    dlgname  db "WinampHookDlg",0
    DebugMessage db "Debug Message",0
    DebugTitle   db "Debug Title",0
        
    .data?
    
    hInstance dd ?
    hRemoteHook dd ?

; «««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««««

    .code
    
start:
    
    invoke GetModuleHandle,NULL
    mov hInstance,eax
    invoke DialogBoxParam, hInstance, ADDR dlgname, HWND_DESKTOP, ADDR WndProc, NULL
    ;invoke InstallHook,hInstance
    ;invoke MessageBoxA, NULL, CTEXT ('Click to end'), CTEXT ('Running...'), MB_OK
    ;invoke UninstallHook
    invoke ExitProcess,NULL

; -------------------------------------------------------------------------

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    .if uMsg == WM_CLOSE
        .if HookFlag == TRUE
            invoke UninstallHook
        .endif
        invoke EndDialog,hWin,NULL
    .elseif uMsg == WM_INITDIALOG
        .if HookFlag == FALSE
            invoke InstallHook,hInstance
            .if eax!=NULL
                mov HookFlag,TRUE
            .else
                ; No hook was set, the program should exit
                invoke MessageBox,0,CTEXT('Target process not running, exiting'),CTEXT('EXE Says'),0
                invoke EndDialog,hWin,NULL
            .endif
        .endif
    .elseif uMsg == WM_REMOTEHOOK
        push 0
        push offset DebugTitle
        push offset DebugMessage
        push 0
        call MessageBox
    .elseif uMsg == WM_COMMAND
        .if wParam == 900 ; Quit
            .if HookFlag == TRUE
                invoke UninstallHook
            .endif
            invoke EndDialog,hWin,NULL
        .endif
    .else
        mov eax,FALSE
        ret
    .endif
    mov eax,TRUE
    ret
WndProc endp

; -------------------------------------------------------------------------

end start

